<?php
if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' );
/**
* The ps_authorize class, containing the payment processing code
*  for transactions with authorize.net 
*
* @version $Id: ps_authorize.php 1095 2007-12-19 20:19:16Z soeren_nb $
* @package VirtueMart
* @subpackage payment
* @copyright Copyright (C) 2004-2007 soeren - All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* VirtueMart is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See /administrator/components/com_virtuemart/COPYRIGHT.php for copyright notices and details.
*
* http://virtuemart.net
*/

class ps_worldnet_hpp {

	var $payment_code = "WORLDNET";
	var $classname = "ps_worldnet_hpp";

	/**
    * Show all configuration parameters for this payment method
    * @returns boolean False when the Payment method has no configration
    */
	function show_configuration() {

		global $VM_LANG, $sess;
		$db =& new ps_DB;
		$payment_method_id = vmGet( $_REQUEST, 'payment_method_id', null );
		/** Read current Configuration ***/
		require_once(CLASSPATH . "../languages/checkout/" . $this->classname . "_lang.php");
		require_once(CLASSPATH . "payment/" . $this->classname . ".cfg.php");
    ?>
      <table>
        <tr>
            <td><strong><?php echo PHPSHOP_ADMIN_CFG_WORLDNET_GATEWAY ?></strong></td>
            <td>
                <select name="WNTPS_GATEWAY" class="inputbox" >
                <option <?php if (WNTPS_GATEWAY == 'worldnet') echo "selected=\"selected\""; ?> value="payments"><?php echo PHPSHOP_ADMIN_CFG_WORLDNET_GATEWAY_WORLDNET ?></option>
                <option <?php if (WNTPS_GATEWAY == 'cashflows') echo "selected=\"selected\""; ?> value="cashflows"><?php echo PHPSHOP_ADMIN_CFG_WORLDNET_GATEWAY_CASHFLOWS ?></option>
                </select>
            </td>
            <td><?php echo PHPSHOP_ADMIN_CFG_WORLDNET_GATEWAY_EXPLAIN ?>
            </td>
        </tr>
        <tr>
            <td><strong><?php echo PHPSHOP_ADMIN_CFG_ENABLE_WORLDNETTPS_TESTMODE ?></strong></td>
            <td>
                <select name="WNTPS_TEST_REQUEST" class="inputbox" >
                <option <?php if (WNTPS_TEST_REQUEST == 'TRUE') echo "selected=\"selected\""; ?> value="TRUE"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_YES') ?></option>
                <option <?php if (WNTPS_TEST_REQUEST == 'FALSE') echo "selected=\"selected\""; ?> value="FALSE"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_NO') ?></option>
                </select>
            </td>
            <td><?php echo PHPSHOP_ADMIN_CFG_ENABLE_WORLDNETTPS_TESTMODE_EXPLAIN ?>
            </td>
        </tr>
        <tr>
            <td><strong><?php echo PHPSHOP_ADMIN_CFG_WORLDNETTPS_TERMINALID ?></strong></td>
            <td>
                <input type="text" name="WNTPS_TERMINALID" class="inputbox" value="<?php echo WNTPS_TERMINALID ?>" />
            </td>
            <td><?php echo PHPSHOP_ADMIN_CFG_WORLDNETTPS_TERMINALID_EXPLAIN ?>
            </td>
        </tr>
        <tr>
            <td><strong><?php echo PHPSHOP_ADMIN_CFG_WORLDNETTPS_SHARED_SECRET ?></strong></td>
            <td>
                <input type="text" name="WNTPS_SHAREDSECRET" class="inputbox" value="<?php echo WNTPS_SHAREDSECRET ?>" />
            </td>
            <td><?php echo PHPSHOP_ADMIN_CFG_WORLDNETTPS_SHARED_SECRET_EXPLAIN ?>
            </td>
        </tr>
        <tr>
            <td><strong><?php echo PHPSHOP_ADMIN_CFG_ENABLE_WORLDNETTPS_HOST_EMAIL ?></strong></td>
            <td>
                <select name="WNTPS_SEND_HOST_EMAIL" class="inputbox" >
                <option <?php if (WNTPS_SEND_HOST_EMAIL == 'TRUE') echo "selected=\"selected\""; ?> value="TRUE"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_YES') ?></option>
                <option <?php if (WNTPS_SEND_HOST_EMAIL == 'FALSE') echo "selected=\"selected\""; ?> value="FALSE"><?php echo $VM_LANG->_('PHPSHOP_ADMIN_CFG_NO') ?></option>
                </select>
            </td>
            <td><?php echo PHPSHOP_ADMIN_CFG_ENABLE_WORLDNETTPS_HOST_EMAIL_EXPLAIN ?>
            </td>
        </tr>
        <tr>
            <td><strong><?php echo PHPSHOP_ADMIN_CFG_WNTPS_STATUS_SUCCESS ?></strong></td>
            <td>
                <select name="WNTPS_VERIFIED_STATUS" class="inputbox" >
                <?php
                    $q = "SELECT order_status_name,order_status_code FROM #__{vm}_order_status ORDER BY list_order";
                    $db->query($q);
                    $order_status_code = Array();
                    $order_status_name = Array();
                    
                    while ($db->next_record()) {
                      $order_status_code[] = $db->f("order_status_code");
                      $order_status_name[] =  $db->f("order_status_name");
                    }
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                      echo "<option value=\"" . $order_status_code[$i];
                      if (WNTPS_VERIFIED_STATUS == $order_status_code[$i]) 
                         echo "\" selected=\"selected\">";
                      else
                         echo "\">";
                      echo $order_status_name[$i] . "</option>\n";
                    }?>
                    </select>
            </td>
            <td><?php echo PHPSHOP_ADMIN_CFG_WNTPS_STATUS_SUCCESS_EXPLAIN ?>
            </td>
        </tr>
            <tr>
            <td><strong><?php echo PHPSHOP_ADMIN_CFG_WNTPS_STATUS_FAILED ?></strong></td>
            <td>
                <select name="WNTPS_FAILED_STATUS" class="inputbox" >
                <?php
                    for ($i = 0; $i < sizeof($order_status_code); $i++) {
                      echo "<option value=\"" . $order_status_code[$i];
                      if (WNTPS_FAILED_STATUS == $order_status_code[$i]) 
                         echo "\" selected=\"selected\">";
                      else
                         echo "\">";
                      echo $order_status_name[$i] . "</option>\n";
                    } ?>
                    </select>
            </td>
            <td><?php echo PHPSHOP_ADMIN_CFG_WNTPS_STATUS_FAILED_EXPLAIN ?></td>
        </tr>
    </table>
    	<?php
		return true;
	}

	function has_configuration() {
		return true;
	}

	function configfile_writeable() {
		return is_writeable( CLASSPATH."payment/".$this->classname.".cfg.php" );
	}

	function configfile_readable() {
		return is_readable( CLASSPATH."payment/".$this->classname.".cfg.php" );
	}

	function write_configuration( &$d ) {

		require_once(CLASSPATH . "../languages/checkout/" . $this->classname . "_lang.php");
		
		$my_config_array = array("WNTPS_GATEWAY" => $d['WNTPS_GATEWAY'],
		"WNTPS_TEST_REQUEST" => $d['WNTPS_TEST_REQUEST'],
		"WNTPS_TERMINALID" => $d['WNTPS_TERMINALID'],
		"WNTPS_SHAREDSECRET" => $d['WNTPS_SHAREDSECRET'],
		"WNTPS_SEND_HOST_EMAIL" => $d['WNTPS_SEND_HOST_EMAIL'],
		"WNTPS_VERIFIED_STATUS" => $d['WNTPS_VERIFIED_STATUS'],
		"WNTPS_FAILED_STATUS" => $d['WNTPS_FAILED_STATUS'],
		);
		$config = "<?php\n";
		$config .= "if( !defined( '_VALID_MOS' ) && !defined( '_JEXEC' ) ) die( 'Direct Access to '.basename(__FILE__).' is not allowed.' ); \n\n";
		foreach( $my_config_array as $key => $value ) {
			$config .= "define ('$key', '$value');\n";
		}

		$config .= "\n?>";

		if ($fp = fopen(CLASSPATH ."payment/".$this->classname.".cfg.php", "w")) {
			fputs($fp, $config, strlen($config));
			fclose ($fp);
			return true;
		}
		else {
			return false;
		}
	}

	function process_payment($order_number, $order_total, &$d) {
		return true;
	}

	function capture_payment( &$d ) {
		return true;
	}
}

